package main

type Item struct {
	Name   string
	Weight int32
}

type Vault struct {
	Res        string
	Alch       string
	Misc       string
	Rec        string
	Parts      string
	Other      string
	ResSize    int32
	AlchSize   int32
	MiscSize   int32
	RecSize    int32
	PartsSize  int32
	OtherSize  int32
	ResCount   int32
	AlchCount  int32
	MiscCount  int32
	RecCount   int32
	PartsCount int32
	OtherCount int32
}

var items = map[string]Item{
	"01":  Item{"Thread", 1},
	"02":  Item{"Stick", 1},
	"03":  Item{"Pelt", 1},
	"04":  Item{"Bone", 1},
	"05":  Item{"Coal", 1},
	"06":  Item{"Charcoal", 1},
	"07":  Item{"Powder", 1},
	"08":  Item{"Iron Ore", 2},
	"09":  Item{"Cloth", 1},
	"10":  Item{"Silver Ore", 2},
	"100": Item{"Pouch of Gold", 0},
	"11":  Item{"Bauxite", 2},
	"12":  Item{"Cord", 2},
	"13":  Item{"Magic Stone", 1},
	"14":  Item{"Wooden Shaft", 2},
	"15":  Item{"Sapphire", 2},
	"16":  Item{"Solvent", 2},
	"17":  Item{"Ruby", 2},
	"18":  Item{"Hardener", 2},
	"19":  Item{"Steel", 2},
	"20":  Item{"Leather", 1},
	"21":  Item{"Bone Powder", 1},
	"22":  Item{"String", 1},
	"23":  Item{"Coke", 1},
	"24":  Item{"Purified Powder", 1},
	"25":  Item{"Silver Alloy", 3},
	"27":  Item{"Steel Mold", 2},
	"28":  Item{"Silver Mold", 2},
	"29":  Item{"Blacksmith Frame", 3},
	"30":  Item{"Artisan Frame", 3},
	"31":  Item{"Rope", 1},
	"32":  Item{"Silver Frame", 2},
	"33":  Item{"Metal Plate", 2},
	"34":  Item{"Metallic Fiber", 2},
	"35":  Item{"Crafted Leather", 1},
	//	"36": Item{"Resurrection Mix", 1},
	"36":   Item{"Quality Cloth", 2},
	"37":   Item{"Blacksmith Mold", 3},
	"38":   Item{"Artisan Mold", 3},
	"39":   Item{"Stinky Sumac", 1},
	"40":   Item{"Mercy Sassafras", 1},
	"41":   Item{"Cliff Rue", 1},
	"42":   Item{"Love Creeper", 1},
	"43":   Item{"Wolf Root", 1},
	"44":   Item{"Swamp Lavender", 1},
	"45":   Item{"White Blossom", 1},
	"46":   Item{"Ilaves", 1},
	"47":   Item{"Ephijora", 1},
	"48":   Item{"Storm Hyssop", 1},
	"49":   Item{"Cave Garlic", 1},
	"50":   Item{"Yellow Seed", 1},
	"51":   Item{"Tecceagrass", 1},
	"52":   Item{"Spring Bay Leaf", 1},
	"53":   Item{"Ash Rosemary", 1},
	"54":   Item{"Sanguine Parsley", 1},
	"55":   Item{"Sun Tarragon", 1},
	"56":   Item{"Maccunut", 1},
	"57":   Item{"Dragon Seed", 1},
	"58":   Item{"Queen's Pepper", 1},
	"59":   Item{"Plasma of Abyss", 1},
	"60":   Item{"Ultramarine Dust", 1},
	"61":   Item{"Ethereal Bone", 1},
	"62":   Item{"Itacory", 1},
	"63":   Item{"Assassin Vine", 1},
	"64":   Item{"Kloliarway", 1},
	"65":   Item{"Astrulic", 1},
	"66":   Item{"Flammia Nut", 1},
	"67":   Item{"Plexisop", 1},
	"68":   Item{"Mammoth Dill", 1},
	"69":   Item{"Silver Dust", 1},
	"501":  Item{"Wrapping", 2},
	"502":  Item{"Leash", 2},
	"505":  Item{"Wooden Arrow", 10},
	"507":  Item{"Bottle of Remedy", -1},
	"509":  Item{"Bottle of Poison", -1},
	"511":  Item{"Steel Arrow", 10},
	"513":  Item{"Silver Arrow", 10},
	"515":  Item{"Broad Arrows Pack", -1},
	"517":  Item{"Heavy Arrows Pack", -1},
	"519":  Item{"Compound Arrows Pack", -1},
	"614":  Item{"Gift Coupon: Pig", 1},
	"615":  Item{"Gift Coupon: Horse", 1},
	"617":  Item{"Gift Coupon: Mouse", 1},
	"618":  Item{"Hay", 5},      // PROPAGATE TO WIKI
	"619":  Item{"Corn", 5},     // PROPAGATE TO WIKI
	"620":  Item{"Hamsters", 5}, // PROPAGATE TO WIKI
	"621":  Item{"Cheese", 5},   // PROPAGATE TO WIKI
	"623":  Item{"Gift Coupon: Ant", 1},
	"624":  Item{"Gift Coupon: Spider", 1},
	"625":  Item{"Gift Coupon: Haunted", 1},
	"626":  Item{"Gift Coupon: Camel", 1},
	"a01":  Item{"Cloth Jacket", -1},
	"a02":  Item{"Leather Shirt", -1},
	"a03":  Item{"Chain Mail", -1},
	"a04":  Item{"Silver Cuirass", -1},
	"a05":  Item{"Mithril Armor", -1},
	"a06":  Item{"Hat", -1},
	"a07":  Item{"Leather Hood", -1},
	"a08":  Item{"Steel Helmet", -1},
	"a09":  Item{"Silver Helmet", -1},
	"a10":  Item{"Mithril Helmet", 190}, // PROPAGATE TO WIKI
	"a11":  Item{"Sandals", -1},
	"a12":  Item{"Leather Shoes", -1},
	"a13":  Item{"Steel Boots", -1},
	"a14":  Item{"Silver Boots", -1},
	"a15":  Item{"Mithril Boots", -1},
	"a16":  Item{"Gloves (Item)", -1},
	"a17":  Item{"Leather Gloves", -1},
	"a18":  Item{"Steel Gauntlets", -1},
	"a19":  Item{"Silver Gauntlets", -1},
	"a20":  Item{"Mithril Gauntlets", 125}, // PROPAGATE TO WIKI
	"a21":  Item{"Wooden Shield", -1},
	"a22":  Item{"Skeleton Buckler", -1},
	"a23":  Item{"Bronze Shield", -1},
	"a24":  Item{"Silver Shield", -1},
	"a25":  Item{"Mithril Shield", -1},
	"a26":  Item{"Royal Guard Cape", -1},
	"a27":  Item{"Order Armor", -1},
	"a28":  Item{"Order Helmet", 190},
	"a29":  Item{"Order Boots", -1},
	"a30":  Item{"Order Gauntlets", -1},
	"a31":  Item{"Order Shield", -1},
	"a32":  Item{"Hunter Armor", 450},
	"a33":  Item{"Hunter Helmet", 190},
	"a34":  Item{"Hunter Boots", -1},
	"a35":  Item{"Hunter Gloves", 125}, // PROPAGATE TO WIKI
	"a36":  Item{"Clarity Robe", 450},
	"a37":  Item{"Clarity Circlet", 190},
	"a38":  Item{"Clarity Shoes", 125},
	"a39":  Item{"Clarity Bracers", 125},
	"a40":  Item{"Pencil of Truth", 10},
	"a41":  Item{"Bard's Cape", -1},
	"a45":  Item{"Crusader Armor", -1},
	"a46":  Item{"Crusader Helmet", -1},
	"a47":  Item{"Crusader Boots", 200},
	"a48":  Item{"Crusader Gauntlets", -1},
	"a49":  Item{"Crusader Shield", 200},
	"a50":  Item{"Royal Armor", -1},
	"a51":  Item{"Royal Helmet", -1},
	"a52":  Item{"Royal Boots", 200},
	"a53":  Item{"Royal Gauntlets", -1},
	"a54":  Item{"Royal Shield", 200},
	"a55":  Item{"Ghost Armor", 480},
	"a56":  Item{"Ghost Helmet", 200},
	"a57":  Item{"Ghost Boots", 90},
	"a58":  Item{"Ghost Gloves", -1},
	"a59":  Item{"Lion Armor", -1},
	"a60":  Item{"Lion Helmet", 200},
	"a61":  Item{"Lion Boots", -1},
	"a62":  Item{"Lion Gloves", -1},
	"a63":  Item{"Demon Robe", 480},
	"a64":  Item{"Demon Circlet", 200},
	"a65":  Item{"Demon Shoes", 140},
	"a66":  Item{"Demon Bracers", 140},
	"a67":  Item{"Divine Robe", 480},
	"a68":  Item{"Divine Circlet", 200},
	"a69":  Item{"Divine Shoes", 140},
	"a70":  Item{"Divine Bracers", 140},
	"a71":  Item{"Storm Cloak", -1},
	"a72":  Item{"Durable Cloak", 30}, // PROPAGATE TO WIKI
	"a73":  Item{"Blessed Cloak", 30},
	"a74":  Item{"Hiking Jar", -1},
	"a75":  Item{"Hiking Bag", -1},
	"a76":  Item{"Stick of Wisdom", 10},
	"a78":  Item{"Council Armor", 510},
	"a79":  Item{"Council Helmet", -1},
	"a80":  Item{"Council Boots", -1},
	"a81":  Item{"Council Gloves", 155},
	"a82":  Item{"Council Shield", -1},
	"a83":  Item{"Griffin Armor", -1},
	"a84":  Item{"Griffin Helmet", -1},
	"a85":  Item{"Griffin Boots", 155},
	"a86":  Item{"Griffin Gloves", 155},
	"a87":  Item{"Celestial Armor", 510},
	"a88":  Item{"Celestial Helmet", 210},
	"a89":  Item{"Celestial Boots", 155},
	"a90":  Item{"Celestial Gloves", 155},
	"a100": Item{"Assault Cape", -1},
	"a101": Item{"Craftsman Apron", -1},
	"a102": Item{"Stoneskin Cloak", -1},
	"ch1":  Item{"Zombie Chest", -1},
	"e1":   Item{"Cocoa Powder", 1},
	"e109": Item{"Walker Armor (Event Gear)", -1},
	"e110": Item{"Walker Helmet (Event Gear)", -1},
	"e111": Item{"Walker Boots (Event Gear)", -1},
	"e112": Item{"Walker Gauntlets (Event Gear)", -1},
	"e113": Item{"Walker Shield (Event Gear)", -1},
	"e114": Item{"Zombie Armor (Event Gear)", 480},
	"e115": Item{"Zombie Helmet (Event Gear)", -1},
	"e116": Item{"Zombie Boots (Event Gear)", 140},
	"e117": Item{"Zombie Gauntlets (Event Gear)", 140},
	"e118": Item{"Zombie Shield (Event Gear)", -1},
	"e125": Item{"Demon Shoes (Event Item)", -1},
	"e128": Item{"Manwolf Helmet (Event Gear)", -1},
	"e130": Item{"Manwolf Gloves (Event Gear)", -1},
	"e132": Item{"Werewolf Helmet (Event Gear)", 200},
	"e139": Item{"Nosferatu Armor (Event Gear)", -1},
	"e144": Item{"War Club", -1},
	"e147": Item{"Manwolf Knife (Event Gear)", -1},
	"e150": Item{"Walker Club (Event Gear)", -1},
	"e153": Item{"Werewolf Knife (Event Gear)", -1},
	"e2":   Item{"Egg", 1},
	"e3":   Item{"Flour", 1},
	"e4":   Item{"Milk", -1},
	"e5":   Item{"Sugar", -1},
	//	"est": Item{"👹Evil Spirits Totem", -1},
	"est":   Item{"Evil Spirits Totem", 50},
	"hw102": Item{"Timeless Jade", -1},
	"hw104": Item{"Shadow Bloodstone", -1},
	"hw107": Item{"Void Emerald", -1},
	"k01":   Item{"Champion Blade", 10},
	"k02":   Item{"Trident Blade", 10}, // PROPAGATE TO WIKI
	"k03":   Item{"Hunter Shaft", 10},
	"k04":   Item{"War Hammer Head", 10},   // PROPAGATE TO WIKI
	"k05":   Item{"Hunter Blade", 10},      // PROPAGATE TO WIKI
	"k06":   Item{"Order Armor Piece", 10}, // PROPAGATE TO WIKI
	"k07":   Item{"Order Helmet Fragment", 10},
	"k08":   Item{"Order Boots Part", 10},     // PROPAGATE TO WIKI
	"k09":   Item{"Order Gauntlets Part", 10}, // PROPAGATE TO WIKI
	"k10":   Item{"Order Shield Part", 10},    // PROPAGATE TO WIKI
	"k11":   Item{"Hunter Armor Part", 10},
	"k12":   Item{"Hunter Helmet Fragment", 10},
	"k13":   Item{"Hunter Boots Part", 10},
	"k14":   Item{"Hunter Gloves Part", 10},
	"k15":   Item{"Clarity Robe Piece", 10},       // PROPAGATE TO WIKI
	"k16":   Item{"Clarity Circlet Fragment", 10}, // PROPAGATE TO WIKI
	"k17":   Item{"Clarity Shoes Part", 10},       // PROPAGATE TO WIKI
	"k18":   Item{"Clarity Bracers Part", 10},     // PROPAGATE TO WIKI
	"k19":   Item{"Thundersoul Blade", 10},        // PROPAGATE TO WIKI
	"k20":   Item{"Doomblade Blade", -1},
	"k21":   Item{"Eclipse Blade", 10}, // PROPAGATE TO WIKI
	"k22":   Item{"Guard's Blade", 10},
	"k23":   Item{"King's Defender Blade", 10},
	"k24":   Item{"Raging Lance Blade", 10},  // PROPAGATE TO WIKI
	"k25":   Item{"Composite Bow Shaft", 10}, // PROPAGATE TO WIKI
	"k26":   Item{"Lightning Bow Shaft", -1},
	"k27":   Item{"Hailstorm Bow Shaft", 10}, // PROPAGATE TO WIKI
	"k28":   Item{"Imperial Axe Head", 10},   // PROPAGATE TO WIKI
	"k29":   Item{"Skull Crusher Head", 10},  // PROPAGATE TO WIKI
	"k30":   Item{"Dragon Mace Head", 10},    // PROPAGATE TO WIKI
	"k31":   Item{"Ghost Blade", 10},         // PROPAGATE TO WIKI
	"k32":   Item{"Lion Blade", 10},          // PROPAGATE TO WIKI
	"k33":   Item{"Crusader Armor Piece", -1},
	"k34":   Item{"Crusader Helmet Fragment", -1},
	"k35":   Item{"Crusader Boots Part", -1},
	"k36":   Item{"Crusader Gauntlets Part", -1},
	"k37":   Item{"Crusader Shield Part", 10}, // PROPAGATE TO WIKI
	"k38":   Item{"Royal Armor Piece", -1},
	"k39":   Item{"Royal Helmet Fragment", -1},
	"k40":   Item{"Royal Boots Part", -1},
	"k41":   Item{"Royal Gauntlets Part", -1},
	"k42":   Item{"Royal Shield Part", -1},
	"k43":   Item{"Ghost Armor Part", 10},       // PROPAGATE TO WIKI
	"k44":   Item{"Ghost Helmet Fragment", 10},  // PROPAGATE TO WIKI
	"k45":   Item{"Ghost Boots Part", 10},       // PROPAGATE TO WIKI
	"k46":   Item{"Ghost Gloves Part", 10},      // PROPAGATE TO WIKI
	"k47":   Item{"Lion Armor Part", 10},        // PROPAGATE TO WIKI
	"k48":   Item{"Lion Helmet Fragment", 10},   // PROPAGATE TO WIKI
	"k49":   Item{"Lion Boots Part", 10},        // PROPAGATE TO WIKI
	"k50":   Item{"Lion Gloves Part", 10},       // PROPAGATE TO WIKI
	"k51":   Item{"Demon Robe Piece", 10},       // PROPAGATE TO WIKI
	"k52":   Item{"Demon Circlet Fragment", 10}, // PROPAGATE TO WIKI
	"k53":   Item{"Demon Shoes Part", 10},       // PROPAGATE TO WIKI
	"k54":   Item{"Demon Bracers Part", 10},     // PROPAGATE TO WIKI
	"k55":   Item{"Divine Robe Piece", 10},      // PROPAGATE TO WIKI
	"k56":   Item{"Divine Circlet Fragment", -1},
	"k57":   Item{"Divine Shoes Part", 10},   // PROPAGATE TO WIKI
	"k58":   Item{"Divine Bracers Part", 10}, // PROPAGATE TO WIKI
	"k59":   Item{"Storm Cloak Part", 10},    // PROPAGATE TO WIKI
	"k60":   Item{"Durable Cloak Part", -1},
	"k61":   Item{"Blessed Cloak Part", 10},  // PROPAGATE TO WIKI
	"k78":   Item{"Council Armor Part", 10},  // PROPAGATE TO WIKI
	"k79":   Item{"Council Helmet Part", 10}, // PROPAGATE TO WIKI
	"k80":   Item{"Council Boots Part", 10},  // PROPAGATE TO WIKI
	"k81":   Item{"Council Gloves Part", 10},
	"k82":   Item{"Council Shield Part", -1},
	"k83":   Item{"Griffin Armor Part", -1},
	"k84":   Item{"Griffin Helmet Part", 10}, // PROPAGATE TO WIKI
	"k85":   Item{"Griffin Boots Part", -1},
	"k86":   Item{"Griffin Gloves Part", 10},   // PROPAGATE TO WIKI
	"k87":   Item{"Celestial Armor Part", 10},  // PROPAGATE TO WIKI
	"k88":   Item{"Celestial Helmet Part", 10}, // PROPAGATE TO WIKI
	"k89":   Item{"Celestial Boots Part", -1},
	"k90":   Item{"Celestial Gloves Part", -1},
	"k91":   Item{"Griffin Knife Part", -1},
	"k92":   Item{"Minotaur Sword Part", -1},
	"k93":   Item{"Phoenix Sword Part", -1},
	"k94":   Item{"Heavy Fauchard Part", -1},
	"k95":   Item{"Guisarme Part", -1},
	"k96":   Item{"Meteor Bow Part", -1},
	"k97":   Item{"Nightfall Bow Part", -1},
	"k98":   Item{"Black Morningstar Part", -1},
	"k99":   Item{"Maiming Bulawa Part", -1},
	"k100":  Item{"Assault Cape Part", -1},
	"k101":  Item{"Craftsman Apron Part", 10}, // PROPAGATE TO WIKI
	"k102":  Item{"Stoneskin Cloak Part", -1},
	"p01":   Item{"Vial of Rage", 1},   // PROPAGATE TO WIKI
	"p02":   Item{"Potion of Rage", 1}, // PROPAGATE TO WIKI
	"p03":   Item{"Bottle of Rage", 1}, // PROPAGATE TO WIKI
	"p04":   Item{"Vial of Peace", 1},
	"p05":   Item{"Potion of Peace", 1},
	"p06":   Item{"Bottle of Peace", 1},
	"p07":   Item{"Vial of Greed", 1},    // PROPAGATE TO WIKI
	"p08":   Item{"Potion of Greed", 1},  // PROPAGATE TO WIKI
	"p09":   Item{"Bottle of Greed", 1},  // PROPAGATE TO WIKI
	"p10":   Item{"Vial of Nature", 1},   // PROPAGATE TO WIKI
	"p11":   Item{"Potion of Nature", 1}, // PROPAGATE TO WIKI
	"p12":   Item{"Bottle of Nature", 1}, // PROPAGATE TO WIKI
	"p13":   Item{"Vial of Mana", 1},     // PROPAGATE TO WIKI
	"p14":   Item{"Potion of Mana", 1},   // PROPAGATE TO WIKI
	"p15":   Item{"Bottle of Mana", 1},   // PROPAGATE TO WIKI
	"p16":   Item{"Vial of Twilight", 1},
	"p17":   Item{"Potion of Twilight", 1}, // PROPAGATE TO WIKI
	"p18":   Item{"Bottle of Twilight", 1}, // PROPAGATE TO WIKI
	"p19":   Item{"Vial of Morph", 1},      // PROPAGATE TO WIKI
	"p20":   Item{"Potion of Morph", 1},    // PROPAGATE TO WIKI
	"p21":   Item{"Bottle of Morph", 1},    // PROPAGATE TO WIKI
	"pmp":   Item{"Pumpkin", -1},
	"r01":   Item{"Champion Sword Recipe", 10},
	"r02":   Item{"Trident Recipe", 10},
	"r03":   Item{"Hunter Bow Recipe", 10},
	"r04":   Item{"War Hammer Recipe", 10},
	"r05":   Item{"Hunter Dagger Recipe", 10},
	"r06":   Item{"Order Armor Recipe", 10},
	"r07":   Item{"Order Helmet Recipe", 10},
	"r08":   Item{"Order Boots Recipe", 10},
	"r09":   Item{"Order Gauntlets Recipe", 10},
	"r10":   Item{"Order Shield Recipe", 10},
	"r100":  Item{"Assault Cape Recipe", -1},
	"r101":  Item{"Craftsman Apron Recipe", -1},
	"r102":  Item{"Stoneskin Cloak Recipe", -1},
	"r11":   Item{"Hunter Armor Recipe", 10},
	"r12":   Item{"Hunter Helmet Recipe", 10},
	"r13":   Item{"Hunter Boots Recipe", 10},
	"r14":   Item{"Hunter Gloves Recipe", 10},
	"r15":   Item{"Clarity Robe Recipe", 10},
	"r16":   Item{"Clarity Circlet Recipe", 10},
	"r17":   Item{"Clarity Shoes Recipe", 10},
	"r18":   Item{"Clarity Bracers Recipe", 10},
	"r19":   Item{"Thundersoul Sword Recipe", 10},
	"r20":   Item{"Doomblade Sword Recipe", 10},
	"r21":   Item{"Eclipse Recipe", 10},
	"r22":   Item{"Guard's Spear Recipe", 10},
	"r23":   Item{"King's Defender Recipe", 10},
	"r24":   Item{"Raging Lance Recipe", 10},
	"r25":   Item{"Composite Bow Recipe", 10},
	"r26":   Item{"Lightning Bow Recipe", 10},
	"r27":   Item{"Hailstorm Bow Recipe", 10},
	"r28":   Item{"Imperial Axe Recipe", 10},
	"r29":   Item{"Skull Crusher Recipe", 10},
	"r30":   Item{"Dragon Mace Recipe", 10},
	"r31":   Item{"Ghost Dagger Recipe", 10},
	"r32":   Item{"Lion Knife Recipe", 10},
	"r33":   Item{"Crusader Armor Recipe", 10},
	"r34":   Item{"Crusader Helmet Recipe", 10},
	"r35":   Item{"Crusader Boots Recipe", 10},
	"r36":   Item{"Crusader Gauntlets Recipe", 10},
	"r37":   Item{"Crusader Shield Recipe", 10},
	"r38":   Item{"Royal Armor Recipe", 10},
	"r39":   Item{"Royal Helmet Recipe", 10},
	"r40":   Item{"Royal Boots Recipe", 10},
	"r41":   Item{"Royal Gauntlets Recipe", 10},
	"r42":   Item{"Royal Shield Recipe", 10},
	"r43":   Item{"Ghost Armor Recipe", 10},
	"r44":   Item{"Ghost Helmet Recipe", 10},
	"r45":   Item{"Ghost Boots Recipe", 10},
	"r46":   Item{"Ghost Gloves Recipe", 10},
	"r47":   Item{"Lion Armor Recipe", 10}, // PROPAGATE TO WIKI
	"r48":   Item{"Lion Helmet Recipe", 10},
	"r49":   Item{"Lion Boots Recipe", 10},
	"r50":   Item{"Lion Gloves Recipe", 10},
	"r51":   Item{"Demon Robe Recipe", 10},
	"r52":   Item{"Demon Circlet Recipe", 10},
	"r53":   Item{"Demon Shoes Recipe", 10},
	"r54":   Item{"Demon Bracers Recipe", 10},
	"r55":   Item{"Divine Robe Recipe", 10},
	"r56":   Item{"Divine Circlet Recipe", 10},
	"r57":   Item{"Divine Shoes Recipe", 10},
	"r58":   Item{"Divine Bracers Recipe", 10},
	"r59":   Item{"Storm Cloak Recipe", 10},
	"r60":   Item{"Durable Cloak Recipe", 10},
	"r61":   Item{"Blessed Cloak Recipe", 10},
	"r78":   Item{"Council Armor Recipe", 10},  // PROPAGATE TO WIKI
	"r79":   Item{"Council Helmet Recipe", 10}, // PROPAGATE TO WIKI
	"r80":   Item{"Council Boots Recipe", 10},  // PROPAGATE TO WIKI
	"r81":   Item{"Council Gloves Recipe", -1},
	"r82":   Item{"Council Shield Recipe", -1},
	"r83":   Item{"Griffin Armor Recipe", -1},
	"r84":   Item{"Griffin Helmet Recipe", -1},
	"r85":   Item{"Griffin Boots Recipe", -1},
	"r86":   Item{"Griffin Gloves Recipe", 10},  // PROPAGATE TO WIKI
	"r87":   Item{"Celestial Armor Recipe", 10}, // PROPAGATE TO WIKI
	"r88":   Item{"Celestial Helmet Recipe", -1},
	"r89":   Item{"Celestial Boots Recipe", -1},
	"r90":   Item{"Celestial Gloves Recipe", -1},
	"r91":   Item{"Griffin Knife Recipe", -1},
	"r92":   Item{"Minotaur Sword Recipe", -1},
	"r93":   Item{"Phoenix Sword Recipe", -1},
	"r94":   Item{"Heavy Fauchard Recipe", -1},
	"r95":   Item{"Guisarme Recipe", -1},
	"r96":   Item{"Meteor Bow Recipe", -1},
	"r97":   Item{"Nightfall Bow Recipe", -1},
	"r98":   Item{"Black Morningstar Recipe", -1},
	"r99":   Item{"Maiming Bulawa Recipe", -1},
	"s01":   Item{"📕Scroll of Rage", 1},       // CREATE AND PROPAGATE TO WIKI
	"s02":   Item{"📕Scroll of Peace", 1},      // CREATE AND PROPAGATE TO WIKI
	"s03":   Item{"📗Scroll of Rage", 1},       // CREATE AND PROPAGATE TO WIKI
	"s04":   Item{"📗Scroll of Peace", 1},      // CREATE AND PROPAGATE TO WIKI
	"s05":   Item{"📘Scroll of Rage", 1},       // CREATE AND PROPAGATE TO WIKI
	"s06":   Item{"📘Scroll of Peace", 1},      // CREATE AND PROPAGATE TO WIKI
	"s11":   Item{"📕Rare scroll of Rage", 1},  // CREATE AND PROPAGATE TO WIKI
	"s12":   Item{"📕Rare scroll of Peace", 1}, // CREATE AND PROPAGATE TO WIKI
	"s13":   Item{"📗Rare scroll of Rage", 1},  // CREATE AND PROPAGATE TO WIKI
	"s14":   Item{"📗Rare scroll of Peace", 1}, // CREATE AND PROPAGATE TO WIKI
	"s15":   Item{"📘Rare scroll of Rage", 1},  // CREATE AND PROPAGATE TO WIKI
	"s16":   Item{"📘Rare scroll of Peace", 1}, // CREATE AND PROPAGATE TO WIKI
	"s51":   Item{"✒️Sof Engraving", 1},       // CREATE AND PROPAGATE TO WIKI
	"tch":   Item{"Torch", -1},
	"td1":   Item{"Colorless shard", 50}, // PROPAGATE TO WIKI
	"w01":   Item{"Wooden Sword", -1},
	"w02":   Item{"Short Sword", -1},
	"w03":   Item{"Long Sword", 180},
	"w04":   Item{"Widow Sword", -1},
	"w05":   Item{"Knight's Sword", -1},
	"w06":   Item{"Elven Sword", -1},
	"w07":   Item{"Rapier", 180},
	"w08":   Item{"Short Spear", -1},
	"w09":   Item{"Long Spear", -1},
	"w10":   Item{"Lance", -1},
	"w11":   Item{"Elven Spear", -1},
	"w12":   Item{"Halberd", -1},
	"w13":   Item{"Kitchen Knife", -1},
	"w14":   Item{"Battle Knife", -1},
	"w15":   Item{"Steel Dagger", -1},
	"w16":   Item{"Silver Dagger", -1},
	"w17":   Item{"Mithril Dagger", 180},
	"w18":   Item{"Short Bow", -1},
	"w19":   Item{"Wooden Bow", -1},
	"w20":   Item{"Long Bow", -1},
	"w21":   Item{"Elven Bow", -1},
	"w22":   Item{"Forest Bow", -1},
	"w23":   Item{"Club", -1},
	"w24":   Item{"Bone Club", -1},
	"w25":   Item{"Heavy Club", -1},
	"w26":   Item{"Steel Axe", -1},
	"w27":   Item{"Mithril Axe", -1},
	"w28":   Item{"Champion Sword", 180},
	"w29":   Item{"Trident", -1},
	"w30":   Item{"Hunter Bow", -1},
	"w31":   Item{"War Hammer", 180},
	"w32":   Item{"Hunter Dagger", 180},
	"w33":   Item{"Thundersoul Sword", 200},
	"w34":   Item{"Doomblade Sword", -1},
	"w35":   Item{"Eclipse", 200},
	"w36":   Item{"Guard's Spear", -1},
	"w37":   Item{"King's Defender", -1},
	"w38":   Item{"Raging Lance", 200},
	"w39":   Item{"Composite Bow", 200},
	"w40":   Item{"Lightning Bow", 200},
	"w41":   Item{"Hailstorm Bow", 200},
	"w42":   Item{"Imperial Axe", -1},
	"w43":   Item{"Skull Crusher", -1},
	"w44":   Item{"Dragon Mace", 200},
	"w45":   Item{"Ghost Dagger", -1},
	"w46":   Item{"Lion Knife", -1},
	"w91":   Item{"Griffin Knife", -1},
	"w92":   Item{"Minotaur Sword", -1},
	"w93":   Item{"Phoenix Sword", -1},
	"w94":   Item{"Heavy Fauchard", -1},
	"w95":   Item{"Guisarme", -1},
	"w96":   Item{"Meteor Bow", -1},
	"w97":   Item{"Nightfall Bow", -1},
	"w98":   Item{"Black Morningstar", -1},
	"w99":   Item{"Maiming Bulawa", 0}}
